// © 2023 John Breaux
//! A bare-bones toy assembler for the TI MSP430, for use in MicroCorruption
pub mod preamble {
    use super::*;
    pub use error::Error;
    pub use hash::{FromHash, Hash};
    pub use linker::{Linker, Visitor};
    pub use parser::Parser;
    pub use tokenizer::{
        context::Context,
        token::{Token, Type},
        TokenStream, Tokenizer,
    };
}

use preamble::*;
pub mod error;
pub mod hash;
pub mod linker;
pub mod parser;
pub mod tokenizer;
